/******************************************************************************
 *
 *	Papillon
 *	color edition
 *	ver 1.1.0
 *	2008.04
 *	ChoiKyun
 *
 *****************************************************************************/
#include <PalmOS.h>
#include <PalmOSGlue.h>
#include <SonyCLIE.h>
#include "defrsc.h"

//#define GLOBAL_VALUE_DEFINE
#include "game.h"



/******************************************************************************
 *	vg^Cv
 *****************************************************************************/



/******************************************************************************
 *	O[oȒ萔
 *****************************************************************************/



/************************************************
 *	XN[̏
 ***********************************************/
Err
init_screen( void )
{
  UInt16 error, hr_ref_num;
  UInt32 width = 160, height = 160, depth = 8;
  Boolean color;


  // J[T|[gĂ邩
  WinScreenMode( winScreenModeGet, NULL, NULL, NULL, &color );
  if( ! color )
    return -1;

  // SONỸnC]Cu̗L`FbN
  if( ( error = SysLibFind( sonySysLibNameHR, &hr_ref_num ) ) )
    {
      if( error == sysErrLibNotFound )
        error = SysLibLoad( 'libr', sonySysFileCHRLib, &hr_ref_num );
    }

  if( ! error )
    {
      HROpen( hr_ref_num );
      HRWinScreenMode( hr_ref_num,
                       winScreenModeGet,
                       &Screen.save.width,
                       &Screen.save.height,
                       &Screen.save.depth,
                       NULL );
      // nC]ʂɂȂĂA[]ʂɕύXB
      if( Screen.save.width == 320 )
        HRWinScreenMode( hr_ref_num, winScreenModeSet, &width, &height, NULL, NULL );
      // 8bit colorɐݒ
      WinScreenMode( winScreenModeSet, NULL, NULL, &depth, NULL);
      HRClose( hr_ref_num );
    }
  else
    {
      // nC]CuȂB
      WinScreenMode( winScreenModeGet,
                     &Screen.save.width,
                     &Screen.save.height,
                     &Screen.save.depth,
                     NULL );
      WinScreenMode( winScreenModeSet, &width, &height, &depth, NULL );
    }

  // obNXN[쐬
  Screen.back_h = WinCreateOffscreenWindow( BACK_WIDTH, BACK_HEIGHT+BACK_BTM_BLANK,
                                            screenFormat, &error );
  ErrFatalDisplayIf( error, "Error Allocating Offscreen" );

  // XN[̃|C^擾
  Screen.back_p = (void *) BmpGetBits( WinGetBitmap( Screen.back_h ) );
  Screen.lcd_p = (void *) BmpGetBits( WinGetBitmap( WinGetDisplayWindow() ) );

  // XN[NA
  clear_screen();

  return errNone;
}



/************************************************
 *	obNXN[LCDɃRs[
 ***********************************************/
void
copy_buff_to_lcd( void )
{
  int i;
  UInt32 *screen = (UInt32 *) Screen.lcd_p;
  UInt32 *back = (UInt32 *) Screen.back_p + ((BACK_WIDTH * 16 + BACK_W_BLANK) /4);


  for( i = 0; i < GAME_WIN_HEIGHT; i++)
    {
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;

      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;

      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;

      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      back += ((BACK_W_BLANK*2) / 4);	// ] 32Bytes E16dot
      }
}



/************************************************
 *	SʃNA
 ***********************************************/
void
clear_screen( void )
{
  int i;
  UInt32 *screen = (UInt32 *) Screen.back_p;


  for( i = 0; i < BACK_WIDTH * BACK_HEIGHT / 4; i++ )
    {
      *screen++ = 0L;
    }
}



/************************************************
 *	BG`
 ***********************************************/
void
draw_bg( void )
{
  int i;
  UInt32 *screen = (UInt32 *) Screen.back_p + (BACK_WIDTH*16/4) + (BACK_W_BLANK/4);
  UInt32 *bg = BmpGetBits( WinGetBitmap( Bg.handle ) );


  for( i = 0; i < BG_HEIGHT; i++ )
    {
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;

      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;

      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;

      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      screen += ((BACK_W_BLANK*2) / 4);	// ] 32Bytes E16dot
    }
}



/************************************************
 *	XvCg\iobNXN[j
 *	n*nhbg 8bit XvCg
 ***********************************************/
void
sprite( Coord x, Coord y, WinHandle chr_no )
{
  int i, j, w, h;
  UInt8 *chr = BmpGetBits( WinGetBitmap( chr_no ) );
  UInt8 *screen = (UInt8 *) Screen.back_p + (UInt16)(y * BACK_WIDTH) + x;
  RectangleType r;


  // ͈̓`FbN
  if( (UInt16) x >= 160+BACK_W_BLANK || (UInt16) y >= 160+BACK_H_BLANK )
    return;

  // TCY擾
  MemMove( &r, &(chr_no ->windowBounds), sizeof( RectangleType ) );

  h = r.extent.y; w = r.extent.x;

  for( i = 0; i < h; i++ )
    {
      for( j = 0; j < w; j++ )
        {
          if( *chr != TRANS_COLOR )
            *screen = *chr;
          screen++; chr++;
        }
      screen += BACK_WIDTH - w;
    }
}



/************************************************
 *	PSETiobNXN[j
 ***********************************************/
void
pset( Coord x, Coord y, IndexedColorType col, PsetWidthType size )
{
  UInt8 *screen = (UInt8 *) Screen.back_p + (UInt16)(y * BACK_WIDTH) + x;


  // ͈̓`FbN
  if( (UInt16) x >= 160+BACK_W_BLANK || (UInt16) y >= 160+BACK_H_BLANK )
    return;

  *screen = col;

  if( size == bold )
    {
      *(screen + BACK_WIDTH) = col;

      pset( x-1, y, col, nomal );
    }
}



#if 0
/************************************************
 *	POINTiobNXN[j
 ***********************************************/
Boolean
point( Coord x, Coord y, IndexedColorType color )
{
  UInt8 *screen = (UInt8 *) Screen.back_p + (UInt16)(y * BACK_WIDTH) + x;


  // ͈̓`FbN
  if( (UInt16) x >= 160+BACK_W_BLANK || (UInt16) y >= 160+BACK_H_BLANK )
    return false;

  return ( *screen == color  ? true : false );
}
#endif



/************************************************
 *	LINEiobNXN[j
 * http://www2.starcat.ne.jp/~fussy/algo/
 * 
 ***********************************************/
void
line( Coord x0, Coord y0, Coord x1, Coord y1, IndexedColorType col, PsetWidthType size )
{
  int i, e, max;
  int dx = ( x1 > x0 ) ? x1 - x0 : x0 - x1;
  int dy = ( y1 > y0 ) ? y1 - y0 : y0 - y1;
  int sx = ( x1 > x0 ) ? 1 : -1;
  int sy = ( y1 > y0 ) ? 1 : -1;


  if( dx >= dy )
    {
      e = -dx;
      max = (dx + 1) / 2;
      for( i = 0; i < max; i++ )
        {
          pset( x0, y0, col, size );
          pset( x1, y1, col, size );

          x0 += sx;
          x1 -= sx;
          e += 2 * dy;
          if( e >= 0 )
            {
              y0 += sy;
              y1 -= sy;
              e -= 2 * dx;
            }
        }
      if( ((dx + 1) % 2) != 0 )
        {
          pset( x0, y0, col, size );
        }
    }
  else
    {
      e = -dy;
      max = ( dy + 1 ) / 2;
      for( i = 0; i < max; i++ )
        {
          pset( x0, y0, col, size );
          pset( x1, y1, col, size );

          y0 += sy;
          y1 -= sy;
          e += 2 * dx;
          if( e >= 0 )
            {
              x0 += sx;
              x1 -= sx;
              e -= 2 * dy;
            }
        }
      if( ((dy + 1) % 2) != 0 )
        {
          pset( x0, y0, col, size );
        }
    }
}



///////////////////////////////////////////////////////////////////////////////
